##
##  certstrap.spec -- OpenPKG RPM Package Specification
##  Copyright (c) 2000-2020 OpenPKG Project <http://openpkg.org/>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package information
%define       V_certstrap_base  1.2.0
%define       V_certstrap_snap  20200327

#   package information
Name:         certstrap
Summary:      Certificate Authority (CA) Bootstrap Tool
URL:          https://github.com/square/certstrap
Vendor:       CoreOS Project, Square
Packager:     OpenPKG Project
Distribution: OpenPKG Community
Class:        EVAL
Group:        Cryptography
License:      MIT
Version:      %{V_certstrap_base}.%{V_certstrap_snap}
Release:      20200327

#   list of sources
Source0:      http://download.openpkg.org/components/versioned/certstrap/certstrap-%{V_certstrap_snap}.tar.xz

#   build information
BuildPreReq:  OpenPKG, openpkg >= 20160101, go
PreReq:       OpenPKG, openpkg >= 20160101

%description
    Certstrap is a simple certificate manager to bootstrap your own
    certificate authority and public key infrastructure. It was adapted
    from etcd-ca. Certstrap is a very convenient app if you don't feel
    like dealing with OpenSSL, its myriad of options or config files.

%track
    prog certstrap:base = {
        version   = %{V_certstrap_base}
        url       = https://github.com/square/certstrap/releases
        regex     = v(__VER__)\.tar\.gz
    }
    prog certstrap:snap = {
        version   = %{V_certstrap_snap}
        url       = http://download.openpkg.org/components/versioned/certstrap/
        regex     = certstrap-(__VER__)\.tar\.xz
    }

%prep
    %setup -q -n certstrap

%build
    #   build program
    export GOPATH=`pwd`
    cd $GOPATH/src/github.com/square/certstrap
    go build -v .

%install
    #   create directory hierarchy
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/bin

    #   install program
    %{l_shtool} install -c -s -m 755 \
        src/github.com/square/certstrap/certstrap \
        $RPM_BUILD_ROOT%{l_prefix}/bin/

    #   determine installation files
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT %{l_files_std}

%files -f files

%clean

